/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.3 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Mastermodul
Version :
Date    : 09.07.2008
Author  : Joakim Hammer
Company : NTNU
Comments:


Chip type           : ATmega32L
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 512
*****************************************************/

#include <mega32.h>
#include "mega32_defs.h"
#include "data_types.h"
//#include "nmea.h"
//#include "usart.h"
#include "twi_int.h"
#include "string.h"
#include "fiskepakke.h"
#include "main.h"




// I2C Bus functions
#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=1
   .equ __scl_bit=0
#endasm
#include <i2c.h>

// Standard Input/Output functions
#include <stdio.h>
#include <delay.h>


// Declare your global variables here
char adc_pakke[PAKKELENGDE_TIDSLUKER], ferdig_adc_pakke[PAKKELENGDE_TIDSLUKER];
//flagg
char mottak_startet, mottak_complete;
//tellere
int adc_teller, sample_teller, tidsluke_teller;



// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}

// SPI interrupt service routine
interrupt [SPI_STC] void spi_isr(void)
{
unsigned char data;
data=SPDR;
// Place your code here

}


/**********************************************************************
 * Timer 0 output compare interrupt service routine
 * Her kan det legges inn en metode for  sjekke om pakken er falsk
 * For eksempel ved at man oppdager !1 (ikke n, men fler eller frre)
 * pakker i en datablokk.
 * Hvis det er tilfellet kan tellerne nullstilles
 * Slik kan vi unng ddtid hvor vi ikke detekterer pakker...
 **********************************************************************/
interrupt [TIM0_COMP] void timer0_comp_isr(void)
{
// Place your code here
   char data = read_adc(ADC0);

    if(data > ADC_TERSKEL_VERDI && mottak_startet == 0)
    {  //leser 'hy' p adc-porten
           adc_teller++;
           sample_teller++;
           if(adc_teller == TRIG_SAMPLE){
              set_time_capture();
              mottak_startet = 1;
	   }
    }
    else if(mottak_startet == 0)
    {
		adc_teller = 0;
                sample_teller = 0;
    }
    else if(mottak_startet ==1){
        if(data > ADC_TERSKEL_VERDI)adc_teller++;
	sample_teller++;
	if(sample_teller >= SAMPLE_PER_LUKE)
	{  //
	   if(adc_teller >= TIDSLUKE_TERSKEL)
	   {
		 adc_pakke[tidsluke_teller] = 0xFF;
	   }
	   else adc_pakke[tidsluke_teller] = 0xAA;

           tidsluke_teller++;
	   sample_teller = 0;
	   adc_teller = 0;
	   //Hvis pakken er ferdig mottatt
	   if(tidsluke_teller >= PAKKELENGDE_TIDSLUKER){
		    memcpy(ferdig_adc_pakke, adc_pakke, PAKKELENGDE_TIDSLUKER);
		    memset(adc_pakke, 0, sizeof adc_pakke);
		    tidsluke_teller = 0;
		    mottak_startet = 0;
		    mottak_complete = 0xFF;
	   }
        }
    }
    else logfile("feil i timer0_comp_isr()");

}



void set_time_capture(void)
{
    BIT_TRUE(PORTD, 7);
    delay_us(TIME_CAPTURE_DELAY);
    BIT_FALSE(PORTD, 7);
}

void init_main(void)
{
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=0 State5=T State4=T State3=T State2=T State1=T State0=T
PORTB=0x00;
DDRB=0x40;

// Port C initialization
// Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTC=0x00;
DDRC=0x80;

// Port D initialization
// Func7=Out Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=0 State6=0 State5=T State4=T State3=T State2=T State1=T State0=T
PORTD=0x00;
DDRD=0xC0;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 3686,400 kHz
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x02;
TCNT0=0x00;
OCR0=0x0E;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 19200
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;    // (0x19 - 8MHz)(0x0B - 3,6MHz)

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 1000,000 kHz
// ADC Voltage Reference: AREF pin
// Only the 8 most significant bits of
// the AD conversion result are used
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x83;

// SPI initialization
// SPI Type: Slave
// SPI Clock Rate: 2000,000 kHz
// SPI Clock Phase: Cycle Half
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0xC0;
SPSR=0x00;

// Clear the SPI interrupt flag
#asm
    in   r30,spsr
    in   r30,spdr
#endasm

// I2C Bus initialization
i2c_init();

// Global enable interrupts
#asm("sei")


}
void usart_printstring(flash unsigned char *str)
{
  while(*str != '\0')
    putchar(*str++);

  putchar(0x0D);
} // usart_printstring
void usart_printchar(char *str)
{
  while(*str != '\0')
    putchar(*str++);

  putchar(0x0D);
} // usart_printstring

void logfile(flash unsigned char *str){
   usart_printstring(str);
}

void main(void){
// Declare your local variables here
char fiskepakke[4];
char i;

init_main();
twi_init();

for(i='A';i<='Z'; i++){
 putchar(i);
}

delay_ms(1000);
i=0;

 while(1){
     if(mottak_complete == 0xFF){
        //Ny fiskepake mottatt...
        mottak_complete = 0x00;

        if(decode_fiskepakke(ferdig_adc_pakke, fiskepakke) == 1){
           //usart_printstring("synk ok");

           create_PP_pakke(fiskepakke)
           create_RF_pakke();
           transmit_RF_pakke();
        }


     }

     check_RC_in_que()
     check_RC_out_que();
 }
}

void logfile(flash unsigned char *str){
   flash_printstring(str);
}