/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.3 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Mastermodul
Version :
Date    : 09.07.2008
Author  : Joakim Hammer
Company : NTNU
Comments:


Chip type           : ATmega32L
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 512
*****************************************************/

void usart1_reset_rx_buffer(void)
{
  // Reset buffer indexes and counters
  rx_wr_index1 = 0;
  rx_rd_index1 = 0;
  usart1_rx_counter  = 0;
}

void putchar(U08 data)
{
  /* Clear TXC if set */
  if(FLAG_READ(UCSR0A,TXC))
    UCSR0A |= (1 << UCSR0A);

  /* Wait for empty transmit buffer */
  while(!FLAG_READ(UCSR0A,UDRE))
    ;

  UDR0 = data; /* Writing data to UART I/O register */
}/* putchar */

U08 getchar(void)
{
  U08 data;
  /* Waiting for incoming data */
  /*@-infloops@*/
  while(usart_rx_counter == (U08)0)
    ;
  /*@+infloops@*/

  data = rx_buffer[rx_rd_index];

  if(++rx_rd_index == USART0_RX_BUFFER_SIZE)
    rx_rd_index  = 0;

  INTERRUPTS_DISABLE;
  --usart_rx_counter;
  INTERRUPTS_ENABLE;

  return data;               /* Return data. */
}/* getchar */

void usart_rx_string(U08 *s, U08 length)
{
  U08 i;

  for(i=0; i<length; i++)
    {
      *s++ = getchar();
    }
}

void usart_tx_string(U08 *str)
{
  while(*str != '\0')
    putchar(*str++);
}

void usart_printstring(flash unsigned char *str)
{
  while(*str != '\0')
    putchar(*str++);

  putchar(0x0D);
} // usart_printstring